//The huge mofo of a sword you get in OoT. :3

/////////////////
//--EXPLOSION--//
/////////////////
datablock explosionData(BGSwordExplosion : SwordExplosion)
{
	lightStartRadius = 10;
	lightEndRadius = 0;
	particleDensity = 40;
	particleRadius = 2.3;

	uiName = "BigGoron's Sword Slice";
};

//////////////////
//--PROJECTILE--//
//////////////////
AddDamageType("BGSword",   '<bitmap:add-ons/Weapon_TSP/BGSword/CI_BGSword> %1',    '%2 <bitmap:add-ons/Weapon_TSP/BGSword/CI_BGSword> %1',0.75,1);
datablock projectileData(BGSwordProjectile : swordProjectile)
{
	lifetime = 100;
	directDamageType = $DamageType::BGSword;
	radiusDamageType = $DamageType::BGSword;
	directDamage = 90;
	explosion = BGSwordExplosion;
	muzzleVelocity = 200;
};

////////////
//--ITEM--//
////////////

datablock itemData(BGSwordItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BGSwordNH.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "BigGoron's Sword";
	iconName = "./icon_BGSword";
	doColorShift = false;
	colorShiftColor = "0.1 0.196 0.1 1.000";

	 // Dynamic properties defined by the scripts
	image = BGSwordImage;
	canDrop = true;

};

////////////////////
//--WEAPON IMAGE--//
////////////////////
datablock shapeBaseImageData(BGSwordImage)
{
   shapeFile = "./BGSword.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = false;

   className = "WeaponImage";

  
   item = BGSwordItem;
   ammo = " ";
   projectile = BGSwordProjectile;
   projectileType = Projectile;

  
   melee = true;
   doRetraction = false;
  
   armReady = true;

   
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

 	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = RaptorDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "swing";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "Swing";
	stateScript[2]                  = "onSwing";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";
	//stateSequence[2]			= "Swing";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.7;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateSequence[3]			= "Swing";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Swing";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

/////////////////////////
//--SPECIAL FUNCTIONS--//
/////////////////////////
function BGSwordImage::onMount(%this, %obj, %slot)
{
	%obj.hideNode(lHand);
	%obj.hideNode(rHand);
}

function BGSwordImage::onUnMount(%this, %obj, %slot)
{
	%obj.unHideNode(lHand);
	%obj.unHideNode(rHand);
}

//Load the peice-of-shit version that breaks in a few swings
//It doesnt work right yet, so disabled until v3.
//exec("./GKnife.cs");
	