//The peice-of-shit version of the BigGoron's Sword that breaks in a few swings

/////////////
//--AUDIO--//
/////////////

datablock audioProfile(GKnifeSnapSound)
{
	filename = "./OoT_Failure.wav";
	description = AudioClosest3d;
	preload = true;
};

//////////////////
//--PROJECTILE--//
//////////////////

datablock projectileData(GKnifeProjectile : BGSwordProjectile)
{
	explosion = BGswordExplosion;
};

datablock projectileData(GKnifeBrokenProjectile : BGSwordProjectile)
{
	lifetime = 64;
	directDamage = 10;
	explosion = swordExplosion;
};

////////////
//--ITEM--//
////////////

datablock itemData(GKnifeItem : BGSwordItem)
{
	uiName = "Giant's Knife";
	image = GKnifeImage;
};

datablock itemData(GKnifeBrokenItem : GKnifeItem)
{
	uiName = "Giant's Knife [Broken]";
	image = GKnifeBrokenImage;
	iconName = "./icon_GKnifeBroken";
	shapeFile = "./GKnifeBroken.dts";

};


////////////////////
//--WEAPON IMAGE--//
////////////////////
datablock shapeBaseImageData(GKnifeImage : BGSwordImage)
{
	item = GKnifeItem;
	projectile = GKnifeProjectile;
};

datablock shapeBaseImageData(GKnifeBrokenImage : GKnifeImage)
{
	projectile = GKnifeBrokenProjectile;
	item = GKnifeBrokenItem;
	shapeFile = "./GKnifeBroken.dts";
	stateScript[2] = "onPreFire";
	stateSound[0] = "";
};


/////////////////////////
//--SPECIAL FUNCTIONS--//
/////////////////////////

function GKnifeImage::onMount(%this, %obj, %slot)
{
	%obj.hideNode(lHand);
	%obj.hideNode(rHand);
}

function GKnifeImage::onUnMount(%this, %obj, %slot)
{
	%obj.unHideNode(lHand);
	%obj.unHideNode(rHand);
}

function GKnifeBrokenImage::onMount(%this, %obj, %slot)
{
	%obj.hideNode(lHand);
	%obj.hideNode(rHand);
}

function GKnifeBrokenImage::onUnMount(%this, %obj, %slot)
{
	%obj.unHideNode(lHand);
	%obj.unHideNode(rHand);
}

function player::setInventorySlot(%this, %i, %db) 
{
	%this.tool[%slot] = (%db = %db.getID());
	commandToClient(%this.client, 'msgItemPickup', "", %slot, %db.getID(), 1);
}

$Swings = 0;
function GKnifeImage::onSwing(%this, %obj, %slot)
{
	echo("Blade swung.");
	$Swings++;
	if($Swings >= 100)
	{	
		echo("Swings exceeded 100.");
		%obj.mountImage(GKnifeBrokenImage);
		$Swings = 0;
		%obj.setInventorySlot(0, gKnifeBrokenItem);
		for(%i=0;%i<%player.getDatablock().maxTools;%i++) //You'll notice that these are now swapped. This is so that I only do one "for" instead of the original 8. This increases effeciency, but does not change the function of the script.
		{
			if(%player.tool[%i] == 0) continue; //If there's no tool there, forget about it.
			%tool = %player.tool[%i].getID(); //Get the ID of the tool that the player is using. (We loop through %i to get all inventory slots)
			if(%tool == GknifeItem.getID()) //If this is the weapon we're looking for... (Renamed, as I changed the datablock a bit)
			{
				%newGun = nameToID("Gknifebrokenitem"); //Get the ID of the item we want
				player.tool[%i] = %newGun; //Set this slot to the weapon we want
				messageClient(%killer,'MsgItemPickup','',%i, %newGun); //Tells the client to get the weapon.

				continue;
			} 

		}
  	}
}
function GKnifeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%norm)
{
	echo("Collided.");
	if(%col.getClassName() $= "Player")
	{
		$Swings = $Swings + 3;
		echo("Hit a player.");
	}
	else
	{
		$Swings = $Swings + 34;
		echo("Hit a wall, vehicle, or something else.");
	}
	echo($swings);

	Parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
}


	
